/*
 * Copyright (c) 2008 Jesper Karlsson & David Gustafsson
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __XFBIB_BIBTEX_ENTRY_H
#define __XFBIB_BIBTEX_ENTRY_H

#include <glib-object.h>
#include "xfbib-bibtex-field.h"

#define XFBIB_TYPE_BIBTEX_ENTRY             (xfbib_bibtex_entry_get_type())
#define XFBIB_BIBTEX_ENTRY(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), XFBIB_TYPE_BIBTEX_ENTRY, XfbibBibtexEntry))
#define XFBIB_IS_BIBTEX_ENTRY(obj)          (G_TYPE_CHECK_INSTANCE_TYPE((obj), XFBIB_TYPE_BIBTEX_ENTRY))
#define XFBIB_BIBTEX_ENTRY_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST((klass), XFBIB_TYPE_BIBTEX_ENTRY, XfbibBibtexEntryClass))
#define XFBIB_IS_BIBTEX_ENTRY_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE((klass), XFBIB_TYPE_BIBTEX_ENTRY))
#define XFBIB_BIBTEX_ENTRY_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS((obj), XFBIB_TYPE_BIBTEX_ENTRY, XfbibBibtexEntryClass))

G_BEGIN_DECLS

typedef struct _XfbibBibtexEntry         XfbibBibtexEntry;

GType xfbib_bibtex_entry_get_type() G_GNUC_CONST;

XfbibBibtexEntry *xfbib_bibtex_entry_new(GObject *);
GObject *xfbib_bibtex_entry_get_owner(XfbibBibtexEntry *);
gboolean xfbib_bibtex_entry_parse(XfbibBibtexEntry *, const gchar *);
GList *xfbib_bibtex_entry_get_fields(XfbibBibtexEntry *);
void xfbib_bibtex_entry_set_fields(XfbibBibtexEntry *, GList *);
gchar *xfbib_bibtex_entry_get_key(XfbibBibtexEntry *);
void xfbib_bibtex_entry_set_key(XfbibBibtexEntry *, const gchar *);
gchar *xfbib_bibtex_entry_get_bibtype(XfbibBibtexEntry *);
void xfbib_bibtex_entry_set_bibtype(XfbibBibtexEntry *, const gchar *);
gchar xfbib_bibtex_entry_get_separator(XfbibBibtexEntry *);
void xfbib_bibtex_entry_set_separator(XfbibBibtexEntry *, gchar);

#if 0
XfbibBibtexField *xfbib_bibtex_entry_get_field_by_column(XfbibBibtexEntry *, gint);
XfbibStrbuf *xfbib_bibtex_entry_get_bibtype(XfbibBibtexEntry *);
XfbibStrbuf *xfbib_bibtex_entry_get_key(XfbibBibtexEntry *);
void xfbib_bibtex_entry_set_key(XfbibBibtexEntry *, const gchar *);
void xfbib_bibtex_entry_set_bibtype(XfbibBibtexEntry *, const gchar *);
void xfbib_bibtex_entry_set_fields(XfbibBibtexEntry *, GList *);
#endif
G_END_DECLS

#endif //__XFBIB_BIBTEX_ENTRY_H

